# You can override the included template(s) by including variable overrides
# SAST customization: https://docs.gitlab.com/ee/user/application_security/sast/#customizing-the-sast-settings
# Secret Detection customization: https://docs.gitlab.com/ee/user/application_security/secret_detection/#customizing-settings
# Dependency Scanning customization: https://docs.gitlab.com/ee/user/application_security/dependency_scanning/#customizing-the-dependency-scanning-settings
# Container Scanning customization: https://docs.gitlab.com/ee/user/application_security/container_scanning/#customizing-the-container-scanning-settings
# Note that environment variables can be set in several places
# See https://docs.gitlab.com/ee/ci/variables/#cicd-variable-precedence

# container_scanning:
#   variables:
#     DOCKER_IMAGE: ...
#     DOCKER_USER: ...
#     DOCKER_PASSWORD: ...

include:
- template: Security/SAST.gitlab-ci.yml
#- template: Security/Secret-Detection.gitlab-ci.yml
#- template: Jobs/Container-Scanning.gitlab-ci.yml

stages:
- build   # how to only run this on commit?
- test    # how to only run this on commit?
- deploy  # how to only run this upon successful merge into main?

default:
  image: python:3.11-buster
  before_script:
    - python3 -m venv --upgrade-deps ./venv
    - source venv/bin/activate
    #- pip install --use-pep517 -r requirements.txt # https://github.com/pypa/pip/issues/8559
    - pip install --upgrade pip
    - pip install -v -r requirements.txt

build-stage:
  stage: build
  script:
  - mkdocs build --strict --verbose --site-dir test
  artifacts:
    paths:
    - test
    expire_in: 2 hrs
  only:
    - branches # this job will affect every branch except 'main'
  except:
    - main
    - merge_requests

sast:
  stage: test

pages:
  stage: deploy
  script:
  - mkdocs build --verbose
  artifacts:
    paths:
    - public
    expire_in: 2 hrs
  only:
    - main # this job will affect only the 'main' branch
  except:
    changes: # ignore changes to these files
      #- .gitlab-ci.yml
      - CODEOWNERS
      #- .gitlab/*


#docker-compose-build:
#  stage: build
#  image: docker:latest
#  services:
#  - docker:dind
#  before_script:
#  - docker -v
#  - docker compose version
#  script:
#  - echo "Build the container"
#  - docker compose build
  # fix these:
    #8 7.275   Link requires a different Python (3.11.3 not in: '>=2.7, <3.6'): https://files.pythonhosted.org/packages/8e/68/261843fe0fed52c7f4364325bde666c858c582547c6a32e90ce9c184a5d7/watchdog-0.10.6.tar.gz (from https://pypi.org/simple/watchdog/) (requires-python:>=2.7, <3.6)
    #8 15.53 WARNING: Running pip as the 'root' user can result in broken permissions and conflicting behaviour with the system package manager. It is recommended to use a virtual environment instead: https://pip.pypa.io/warnings/venv
  # build outputs to `docker.io/library/dsfca-web` which is where??
    #8 DONE 16.8s
    #9 exporting to image
    #9 exporting layers
    #9 exporting layers 1.5s done
    #9 writing image sha256:2c783db7ff881e79ee69672f6c6efaaec7f847e997e857d687cf1e09b56398cd done
    #9 naming to docker.io/library/dsfca-web done
    #9 DONE 1.5s
    # time="2023-04-11T00:44:55Z" level=warning msg="buildx: git was not found in the system. Current commit information was not captured by the build"
#  after_script:
#  - ls -laR .git
#  artifacts:
#    paths: 
#      - dsfca-web
#    expire_in: 1 day

#pages-deploy:
#  stage: deploy
#  #needs: ["docker-compose-build"]
#  image: docker:latest
#  services:
#  - docker:dind
#  before_script:
#  - docker -v
#  - docker compose version
#  script:
#  - echo "Deploy the site to GitLab Pages"
  #artifacts:
  #  paths:

